/***********************************************************
 * $Id: fancyqmi.h 1535 2015-03-02 22:15:25Z fancylibs $
 *
 * FancyLibs libqml wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMI_H
#define FANCYQMI_H

#define FANCYQMI_ABI 1

#ifdef WIN32
# ifdef __GNUC__
#  ifdef BUILD_fancysane_DLL
#   define FANCYQMI_API __attribute__((dllexport))
#  else
#   define FANCYQMI_API __attribute__((dllimport))
#  endif
# else
#  ifdef BUILD_fancysane_DLL
#   define FANCYQMI_API __declspec(dllexport)
#  else
#   define FANCYQMI_API __declspec(dllimport)
#  endif
# endif
#else
# ifdef __GNUC__
#  define FANCYQMI_INTERNAL_API __attribute__((visibility("hidden")))
# endif
#endif

#ifndef FANCYQMI_INTERNAL_API
#define FANCYQMI_INTERNAL_API
#endif

#ifndef FANCYQMI_API
#define FANCYQMI_API
#endif

namespace Fancy {
namespace QMI {

  const char* FANCYQMI_API fancyqmi_version();
  const char* FANCYQMI_API fancyqmi_builddate();
}}

#endif // ! FANCYQMI_H
