/***********************************************************
 * $Id: fancyqmilog.h 1535 2015-03-02 22:15:25Z fancylibs $
 *
 * FancyLibs qmi wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMI_LOG_H
#define FANCYQMI_LOG_H

#include <fancyqmi.h>

#include <fancylog.h>

// facility "fancyqmi"
#define  FANCYQMI_LOG           (1<<0)
// facility "fancyqmitool"
#define  FANCYQMI_LOG_TOOL      (1<<1)

namespace Fancy {
namespace QMI {

  extern FANCYQMI_API fancylog_service *log_service;

  // parse for logging cmdline args and filter out recognized options.
  void FANCYQMI_API fancylog_parse_arg (int *argc, char **argv);

  inline void vfancylog (int facility,
                         int priority, const char *fmt, va_list ap)
  {
    va_list aq;
    va_copy(aq,ap);
    ::vfancylog(log_service,facility,priority,fmt,aq);
    va_end(aq);
  }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));

#endif

  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
  {
    va_list ap;
    va_start(ap, fmt);
    vfancylog(facility,priority,fmt,ap);
    va_end(ap);
  }
}
}

#endif // ! FANCYQMI_LOG_H
