/***********************************************************
 * $Id: fancyqminetworkstatus.h 1596 2015-03-12 08:14:17Z fancylibs $
 *
 * FancyLibs qmi wrapper
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMINETWORKSTATUS_H_
#define FANCYQMINETWORKSTATUS_H_

#include <fancyqmienums.h>
#include <fancyobject.h>

extern "C" {
typedef struct _QmiIndicationNasEventReportOutput QmiIndicationNasEventReportOutput;
};

namespace Fancy {
namespace QMI {

/**
 * A network status to be reported to listeners.
 */
class FANCYQMI_API QmiNetworkStatus : virtual public Fancy::Object
{
public:
	typedef Fancy::ObjPtr<QmiNetworkStatus> ptr_t;

	static ptr_t newInstance();

	RadioInterface getRadioInterface() const {
		return this->radioInterface;
	}

	void setRadioInterface(RadioInterface radioInterface) {
		this->radioInterface = radioInterface;
	}

	int getSignalStrength() const {
		return this->signalStrength;
	}

	void setSignalStrength(int signalStrength) {
		this->signalStrength = signalStrength;
	}

	std::string toString() const;

protected:

	QmiNetworkStatus();
	virtual ~QmiNetworkStatus();

private:

	RadioInterface radioInterface;
	int signalStrength;
};

}} // end namespaces

#endif
