/***********************************************************
 * $Id: fancyqmisignalinfocallback.h 1605 2015-03-16 08:33:55Z fancylibs $
 *
 * FancyLibs qmi wrapper
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMINETSIGNALINFOCALLBACK_H_
#define FANCYQMINETSIGNALINFOCALLBACK_H_

#include <fancyqmi.h>
#include <fancyobject.h>

namespace Fancy {
namespace QMI {

class QmiSignalInfo;

class FANCYQMI_API QmiSignalInfoCallback : virtual public Fancy::Object
{
public:
	typedef Fancy::ObjPtr<QmiSignalInfoCallback> ptr_t;

	virtual void onSignalInfoChange(const Fancy::ObjPtr<QmiSignalInfo> &status) = 0;

protected:

	QmiSignalInfoCallback();
	virtual ~QmiSignalInfoCallback();
};

}} // end namespaces

#endif
